<?php
namespace nur\sery\file\csv;

use nur\sery\php\time\Date;
use nur\sery\php\time\DateTime;

abstract class AbstractReader  implements IReader {
  const SCHEMA = null;

  const HEADERS = null;

  /** @var ?string nom du fichier depuis lequel lire */
  const INPUT = null;

  function __construct($input, ?array $params=null) {
    if ($input !== null) $params["input"] = $input;
    #
    $this->schema = $params["schema"] ?? static::SCHEMA;
    $this->headers = $params["headers"] ?? static::HEADERS;
    $this->input = $params["input"] ?? static::INPUT;
  }

  protected ?array $schema;

  protected ?array $headers;

  protected $input;

  protected int $isrc = 0, $idest = 0;

  protected function cook(array &$row): bool {
    if ($this->isrc == 0) {
      # ligne d'en-tête
      $headers = $this->headers;
      if ($headers === null) {
        if ($this->schema === null) $headers = null;
        else $headers = array_keys($this->schema);
        if ($headers === null) $headers = $row;
        $this->headers = $headers;
      }
      return false;
    }
    $row = array_combine($this->headers, $row);
    return true;
  }

  protected function verifixCol(&$col): void {
    # conversion Date et DateTime
    if (DateTime::isa_datetime($col, true)) {
      $col = new DateTime($col);
    } elseif (DateTime::isa_date($col, true)) {
      $col = new Date($col);
    }
  }
}
