<?php
namespace nur\sery\file\csv;

use nur\sery\file\web\Upload;
use nur\sery\os\path;
use nur\sery\ValueException;

trait TAbstractReader {
  /** @param Upload|string|array $reader */
  static function with($reader): self {
    if ($reader instanceof self) return $reader;
    $class = null;
    if ($reader instanceof Upload) {
      if ($reader->isExt(".csv")) $class = CsvReader::class;
      else $class = static::class;
      return new $class($reader->tmpName);
    }
    if (is_string($reader)) $reader = ["input" => $reader];
    if (!is_array($reader)) {
      throw ValueException::invalid_type($reader, self::class);
    }
    $input = $reader["input"] ?? null;
    if (is_string($input) && path::ext($input) === ".csv") {
      $class = CsvReader::class;
    }
    if ($class === null) $class = static::class;
    return new $class(null, $reader);
  }
}
